'						January 30, 2000
'						file:gf_morse.bas
'Basic Stamp SBC Call Signer program
'Sends: "W8GF"
'Morse Speed from 13 WPM to 35 WPM (13, 15, 17, 21, 26, and 35)
' Port Assignment:
'	0 = Keyed output reed relay coil driver
'	1 = Low order speed bit
'	2 = Medium order speed bit
'	3 = High order speed bit
'	4 = Spare
'	5 = Sidetone input frequency adjust
'	6 = Audio output to speaker
'	7 = Local/remote input start


'See Drawing Morse Call Sign Generator for hardware details.

'Program starts here 

Symbol	Tone = b5			'Sidetone frequency
Symbol	Quiet = 0
Symbol	Dit_length = b1			'dot storage
Symbol	Dah_length = b3 		'dash storage
Symbol	Wrd_length = 8 		'word length storage
Symbol	Character = b0			'character storage
Symbol	Index1 = b6			'
Symbol	Index2 = b2			'
Symbol	Elements = b4			'

Loop: if Pin7 = 1 then Identify		'search for input
goto loop 

Identify : 
          b7 = pins				'Read Morse speed settings
	  b7 = b7 & 14			'we want only 1, 2 and 3 bits!

	 lookdown b7,(0,0,0,2,4,8,6,10,14),b1    'Set speed.

	 let b3 = b1 * 3			 'set dash length (3 x dot)

Output  0: output 6
for Index1 = 0 to 3
	lookup Index1,(99,229,195,36),Character   'Morse chars sent
	gosub Morse			'sends W8GF
next

goto loop				;look for new input

Morse:pot 5, 105, b5			'Set sidetone frequency

if character = 255 then word_sp
let Elements = Character & %00000111
if Elements = 7 then Adjust1
if Elements = 6 then Adjust2
Bang_Key: 
for Index2 = 1 to Elements
	if Character >= 128 then Dah
	goto Dit
   Reenter:
	let Character = Character * 2
next
gosub char_sp
return

Adjust1:
Elements = 6
goto Bang_Key

Adjust2:
Character = Character & %11111011
goto Bang_Key

end

Dit:
high 0
sound 6,(Tone,Dit_length)
low 0
sound 6,(Quiet,Dit_length)
goto Reenter

Dah:
high 0
sound 6,(Tone,Dah_length)
low 0
sound 6,(Quiet,Dit_length)
goto Reenter

Char_sp:
sound 6,(Quiet,Dah_length)
return

Word_sp:
sound 6,(Quiet,Wrd_length)
return
